<?php
// Si mode silencieux vidage automatique du dossier de sortie
if ($CONF['silentORNOT'] == 'erase') {
  @rrmdir($CONF['DIRsortie']);
  @mkdir($CONF['DIRsortie']);
}


### Supprimer les caractères spéciaux - dossiers & fichiers ###
// Les caractères '%' et '$' sont systématiquement échappés, ca génère des bugs dans les noms de fichiers
function recursive_delete_special_car($dir) {
  $dir = rtrim($dir, '/');
  $dh = opendir($dir);
  
  while (($file = readdir($dh)) !== false ) {
    if ($file !== '.' && $file !== '..') {
      $path = $dir.'/'.$file;
      $new_path = $dir.'/'.delete_special_car($file);
      
      if ($path != $new_path) {
        rename_log($path, $new_path);
      }
      
      if (is_dir($new_path)) {
        recursive_delete_special_car($new_path);
      }
    }
  }
  closedir($dh);
}

recursive_delete_special_car($CONF['DIRsource']);


### Copyright & Options générales des conversion ###
$CONF['copyright'] = utf8_decode($CONF['copyright']);
$CONF['copyCOLOR'] = hex2RGB(nice_hex_color($CONF['copyCOLOR']), true, ' ');

if ($CONF['copyONhd']) {
  $CONF['copyHD'] = '-text_font "'.$CONF['copyFONT'].'" '.$CONF['DIMnormal']*$CONF['copySIZE'].' -text_color '.$CONF['copyCOLOR'].' -text_flag '.$CONF['copyPOS'].' -text_pos 0 0 -text "'.$CONF['copyright'].'"';
} else {
  $CONF['copyHD'] = null;
}

if ($CONF['copyONnormal']) {
  $CONF['copyNormal'] = '-text_font "'.$CONF['copyFONT'].'" '.$CONF['DIMnormal']*$CONF['copySIZE'].' -text_color '.$CONF['copyCOLOR'].' -text_flag '.$CONF['copyPOS'].' -text_pos 0 0 -text "'.$CONF['copyright'].'"';
} else {
  $CONF['copyNormal'] = null;
}

$CONF['convOptions'] = '-ratio -rtype lanczos -rflag decr';
$CONF['allowedExt'] = array('jpg', 'jpeg', 'png', 'gif', 'bmp', 'tiff');


### Plugins avant execution ###
foreach ($CONF['Plugins'] as $plugin_id => $plugin_config) {
  if ($plugin_config['mode'] == 'Before' AND $plugin_config['active']) {
    include('plugins/'.$plugin_id.'/main.php');
  }
}


### Processus principal ###
// Tableau avec les fichiers source
$FilesSource = array();
recursive_readdir($CONF['DIRsource'], 'FilesSource');

// Tableau avec les fichiers de sortie
$FilesSortie = str_replace($CONF['DIRsource'], $CONF['DIRsortie'], $FilesSource);

// Boucle sur tous les fichiers
for ($i=0; $i<count($FilesSource); $i++) {
  // Découpe le nom de fichier : dossier/fichier/extension
  preg_match('#^(.*)/(.*)\.([a-z0-9]{2,4})$#i', $FilesSource[$i], $matches);
  $file['folder_src'] = $matches[1].'/'; // dossier d'entrée
  $file['folder_out'] = str_replace($CONF['DIRsource'], $CONF['DIRsortie'], $file['folder_src']); // dossier de sortie
  $file['name'] = $matches[2]; // nom final
  $file['ext'] = $matches[3]; // extension orginale
      
  // Crée les sous-dossiers de sortie & 'pwg_high' & 'thumbnail'
  if (!file_exists($file['folder_out'].'pwg_high') AND $CONF['DIRhighORNOT']) {
    mkdir_log($file['folder_out'].'pwg_high');
  }
  if (!file_exists($file['folder_out'].'thumbnail')) {
    mkdir_log($file['folder_out'].'thumbnail');
  }
  
  if (!in_arrayi($file['ext'], $CONF['allowedExt'])) {
    $BlockAll['main'] = true;
    $LOG[] = 'Not image file : '.$FilesSource[$i];
  }
  
  if (!isset($BlockAll)) {
    // Informations sur le fichier
    exec('include\nconvert.exe -info "'.$FilesSource[$i].'"', $FileInfos);
    
    for ($m=0; $m<=5; $m++) {
      unset($FileInfos[$m]);
    }
    foreach ($FileInfos as $key) {
      if ($key != '') {
        $a = explode(':', $key);
        $FileInfos[trim($a[0])] = trim($a[1]);
      }
    }
  }
    
  // Plugins pendant l'execution, haute priorité
  foreach ($CONF['Plugins'] as $plugin_id => $plugin_config) {
    if ($plugin_config['mode'] == 'ProcessHigh' AND $plugin_config['active']) {
      include('plugins/'.$plugin_id.'/main.php');
    }
  }
  
  // Plugins pendant l'execution
  foreach ($CONF['Plugins'] as $plugin_id => $plugin_config) {
    if ($plugin_config['mode'] == 'Process' AND $plugin_config['active']) {
      include('plugins/'.$plugin_id.'/main.php');
    }
  }
  
  // Compresse les fichiers dans le dossier de sortie
  if (!isset($BlockNormal) AND !isset($BlockAll)) { 
    nconvert('-q '.$CONF['Qnormal'].' -out jpeg -o "'.$file['folder_out'].$file['name'].'.jpg" -dpi 72 '.$CONF['convOptions'].' -resize '.$CONF['DIMnormal'].' '.$CONF['DIMnormal'].' '.$CONF['copyNormal'].' "'.$FilesSource[$i].'"');
  }
  if (!isset($BlockThumbnail) AND !isset($BlockAll)) { 
    nconvert('-q '.$CONF['Qthumbnail'].' -out jpeg -o "'.$file['folder_out'].'thumbnail/'.$CONF['prefixe_mini'].$file['name'].'.jpg" -dpi 72 '.$CONF['convOptions'].' -resize '.$CONF['DIMthumbnail'].' '.$CONF['DIMthumbnail'].' -rmeta -rexifthumb "'.$FilesSource[$i].'"');
  }
  if (!isset($BlockHigh) AND $CONF['DIRhighORNOT'] AND !isset($BlockAll)) {
    if ($CONF['DIMhdORNOT']) {
      nconvert('-q '.$CONF['Qhd'].' -out jpeg -o "'.$file['folder_out'].'pwg_high/'.$file['name'].'.jpg" -dpi '.$CONF['DPI'].' '.$CONF['convOptions'].' -resize '.$CONF['DIMhd'].' '.$CONF['DIMhd'].' '.$CONF['copyHD'].' "'.$FilesSource[$i].'"');
    } else if (strtolower($file['ext']) != 'jpg') {
      nconvert('-q '.$CONF['Qhd'].' -out jpeg -o "'.$file['folder_out'].'pwg_high/'.$file['name'].'.jpg" "'.$FilesSource[$i].'"');
    } else {
      copy_log($FilesSource[$i], $file['folder_out'].'pwg_high/'.$file['name'].'.jpg');
    }
  }
  
  // Réinitialise les variables
  unset($file, $FileInfos, $BlockNormal, $BlockThumbnail, $BlockHigh, $BlockAll);
  $LOG[] = "\r\n";
}


### Supprime les dossiers vides et copie les fichiers index.php ###
$DirsSortie = array();
recursive_readdir($CONF['DIRsortie'], 'DirsSortie', true);

foreach($DirsSortie as $dir) {
  if (is_dir_empty($dir)) {
    rmdir($dir);
  } else if ($CONF['indexORNOT']) {
    copy_log('include/index.php', $dir.'/index.php');
  }
}

unset($DirsSortie);


### Plugins après execution ###
foreach ($CONF['Plugins'] as $plugin_id => $plugin_config) {
  if ($plugin_config['mode'] == 'After' AND $plugin_config['active']) {
    include('plugins/'.$plugin_id.'/main.php');
  }
}
?>